#!/usr/dist/pkgs/perl,v5.003/5bin.sun4/perl

require 5.003;
BEGIN {
    my($workdir) = ($0 =~ /(.*)\/.*/);
    unshift(@INC, "$workdir/../lib");
}
my($workdir) = ($0 =~ /(.*)\/.*/);
use BER;
use SNMP_Session;
use SNMP_MIB;
use SNMP_Simple;
use Socket;
use strict;

### MAIN ###

my($host) = "$ARGV[0]";
my($community) = "public";

SNMP_MIB::loadoids("$workdir/../mibs", "RFC1213");

my $session = SNMP_Simple->open ($host, $community, 161);
$session->{'retries'} = 1;
my @atifent = $session->snmpgettable('atIfIndex');
if (@atifent) {
  my @atphysaddr = $session->snmpgettable('atPhysAddress');
  my @atnetaddr = $session->snmpgettable('atNetAddress');
  my($ifent, @physaddr, $netaddr);

  foreach $ifent (@atifent) {
    @physaddr = unpack('C*', shift @atphysaddr);
    $netaddr = shift @atnetaddr;
    printf("%03d.%03d.%03d.%03d", split (/\./, $netaddr));
    print("\|");
    printf("%02x", shift @physaddr);
    while(scalar @physaddr) {
      printf(":%02x", shift @physaddr);
    }
    print("\n");
  }
}

$session->close();

exit 0;
