#!/usr/dist/pkgs/perl,v5.003/5bin.sun4/perl

require 5.003;
BEGIN {
    my($workdir) = ($0 =~ /(.*)\/.*/);
    unshift(@INC,"$workdir/../lib");
}
my($workdir) = ($0 =~ /(.*)\/.*/);
use BER;
use SNMP_Session;
use SNMP_MIB;
use SNMP_Simple;
use Socket;
use strict;

### MAIN ###

my($community) = "public";

sub byip {
    my $aip = pack('C4', (split(/./, $a)));
    my $bip = pack('C4', (split(/./, $b)));
    int($aip) <=> int($bip);
}

SNMP_MIB::loadoids("$workdir/../mibs", "RFC1213");

my $line;
while ($line = <>) {
    chomp $line;
    my ($host, $net) = split(/ /, $line);
    my @hostip = gethostbyname($host);
    $hostip[0] = inet_aton($hostip[0]);
    my ($aip,$bip,$cip,$dip) = unpack('C4',$hostip[0]);
    $host = "$aip.$bip.$cip.$dip";
    my $ping = system("/usr/sbin/ping $host 2 > /dev/null 2>&1");
    if ($ping == 0) {
	my $session = SNMP_Simple->open ($host, $community, 161);
	my $ipRouteMaskoid = SNMP_MIB::name2oid('ipRouteMask');
	$session->{'retries'} = 1;
	my ($router) = $session->snmpget('ipForwarding');
	if (defined($router) && ($router == 1)) {
	    my @dests = $session->snmpgettable('ipRouteDest');
	    my %masks = $session->snmpgettablea('ipRouteMask');
	    my ($dest);
	    foreach $dest (sort byip @dests) {
		my $mask = $masks{"$ipRouteMaskoid.$dest"};
		next unless ($dest =~ /^$net/);
		next if ($mask eq "255.255.255.255");
		print "$dest $mask\n";
	    }
	} else {
	}
	$session->close();
    } else {
    }
}

exit 0;
